Package com.sas.metadata.remote

# Interface Person

All Superinterfaces:
  `CMetadata`, `Identity`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Person extends Identity
This type represents the information kept about a person.

Attributes of Person are:

- `Title`

Associations of Person are:

- `EmailAddresses`
- `Locations`
- `PhoneNumbers`
- `SubscriberIdentities`

## Usage

To create an instance of this Person, use the `factory` create methods.
Example: create a Person with name "Person_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Person myObject = (Person) factory.createComplexMetadataObject(objectStore, "Person_Object", MetadataObjects.PERSON, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_EMAILADDRESSES_NAME`
  Constant used for the name of the EmailAddresses association.
  `static final String`
  `ASSOCIATION_LOCATIONS_NAME`
  Constant used for the name of the Locations association.
  `static final String`
  `ASSOCIATION_PHONENUMBERS_NAME`
  Constant used for the name of the PhoneNumbers association.
  `static final String`
  `ASSOCIATION_SUBSCRIBERIDENTITIES_NAME`
  Constant used for the name of the SubscriberIdentities association.
  `static final String`
  `ATTRIBUTE_TITLE_NAME`
  Constant used for the name of the Title attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Identity

  `ASSOCIATION_ACCESSCONTROLENTRIES_NAME, ASSOCIATION_ASSOCIATEDHOMEFOLDER_NAME, ASSOCIATION_IDENTITYCHANGES_NAME, ASSOCIATION_IDENTITYGROUPS_NAME, ASSOCIATION_INTERNALLOGININFO_NAME, ASSOCIATION_LOGINS_NAME, ASSOCIATION_RESPONSIBILITIES_NAME, ATTRIBUTE_DISPLAYNAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AssociationList`
  `getEmailAddresses()`
  Gets the AssociationList of `EmailAddresses`
  `AssociationList`
  `getEmailAddresses(boolean fGoToServer)`
  Gets the Associationlist of `EmailAddresses`
  `AssociationList`
  `getLocations()`
  Gets the AssociationList of `Locations`
  `AssociationList`
  `getLocations(boolean fGoToServer)`
  Gets the Associationlist of `Locations`
  `AssociationList`
  `getPhoneNumbers()`
  Gets the AssociationList of `PhoneNumbers`
  `AssociationList`
  `getPhoneNumbers(boolean fGoToServer)`
  Gets the Associationlist of `PhoneNumbers`
  `AssociationList`
  `getSubscriberIdentities()`
  Gets the Association list of `SubscriberIdentities`
  `AssociationList`
  `getSubscriberIdentities(boolean fGoToServer)`
  Gets the Associationlist of `SubscriberIdentities`
  `String`
  `getTitle()`
  Gets the `String` value of `Title`
  `int`
  `getTitleMaxLength()`
  Gets the maximum length of `Title`
  `int`
  `getTitleState()`
  Gets the Metadata State of `Title`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `EmailAddresses`
  `Locations`
  `PhoneNumbers`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setEmailAddresses(AssociationList list)`
  Sets the `EmailAddresses` list to be `list`.
  `void`
  `setEmailAddresses(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setLocations(AssociationList list)`
  Sets the `Locations` list to be `list`.
  `void`
  `setLocations(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setPhoneNumbers(AssociationList list)`
  Sets the `PhoneNumbers` list to be `list`.
  `void`
  `setPhoneNumbers(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSubscriberIdentities(AssociationList list)`
  Sets the `SubscriberIdentities` list to be `list`.
  `void`
  `setSubscriberIdentities(AssociationList inObjects, int state)`
  Sets the entire SubscriberIdentities list to match the passed in AssociationList, sets the state of the SubscriberIdentities
  `void`
  `setTitle(String inTitle)`
  Sets the `Title` value and sets the state to MetadataState.LOCAL.
  `void`
  `setTitle(String inTitle, int state)`
  Sets the `Title` Metadata State.
  `void`
  `setTitleState(int state)`
  Sets the Metadata State of `Title`.

  ### Methods inherited from interface com.sas.metadata.remote.Identity

  `getAccessControlEntries, getAccessControlEntries, getAssociatedHomeFolder, getAssociatedHomeFolders, getAssociatedHomeFolders, getDisplayName, getDisplayNameMaxLength, getDisplayNameState, getIdentityChanges, getIdentityChanges, getIdentityGroups, getIdentityGroups, getInternalLoginInfo, getInternalLoginInfos, getInternalLoginInfos, getLogins, getLogins, getResponsibilities, getResponsibilities, setAccessControlEntries, setAccessControlEntries, setAssociatedHomeFolder, setAssociatedHomeFolders, setAssociatedHomeFolders, setDisplayName, setDisplayName, setDisplayNameState, setIdentityChanges, setIdentityChanges, setIdentityGroups, setIdentityGroups, setInternalLoginInfo, setInternalLoginInfos, setInternalLoginInfos, setLogins, setLogins, setResponsibilities, setResponsibilities`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_TITLE_NAME

    static final String ATTRIBUTE_TITLE_NAME
    Constant used for the name of the Title attribute.

    Title: This is the persons job title.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_EMAILADDRESSES_NAME

    static final String ASSOCIATION_EMAILADDRESSES_NAME
    Constant used for the name of the EmailAddresses association.

    EmailAddresses: The list of e-mail addresses for this person.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_LOCATIONS_NAME

    static final String ASSOCIATION_LOCATIONS_NAME
    Constant used for the name of the Locations association.

    Locations: The list of locations associated with this person.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PHONENUMBERS_NAME

    static final String ASSOCIATION_PHONENUMBERS_NAME
    Constant used for the name of the PhoneNumbers association.

    PhoneNumbers: The list of phone numbers for a person (or persons).

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SUBSCRIBERIDENTITIES_NAME

    static final String ASSOCIATION_SUBSCRIBERIDENTITIES_NAME
    Constant used for the name of the SubscriberIdentities association.

    SubscriberIdentities: The subscriber profiles for this person.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Identity`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `EmailAddresses`
    `Locations`
    `PhoneNumbers`
    Specified by:
      `initializePredObjects` in interface `Identity`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTitle

    String getTitle() throws RemoteException
    Gets the `String` value of `Title`
    Returns:
      The `Title`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTitleState

    int getTitleState() throws RemoteException
    Gets the Metadata State of `Title`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTitleMaxLength

    int getTitleMaxLength() throws RemoteException
    Gets the maximum length of `Title`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEmailAddresses

    AssociationList getEmailAddresses() throws RemoteException, MdException
    Gets the AssociationList of `EmailAddresses`
    Returns:
      Returns the AssociationList of `EmailAddresses` which can be of type:
      Email
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLocations

    AssociationList getLocations() throws RemoteException, MdException
    Gets the AssociationList of `Locations`
    Returns:
      Returns the AssociationList of `Locations` which can be of type:
      Location
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPhoneNumbers

    AssociationList getPhoneNumbers() throws RemoteException, MdException
    Gets the AssociationList of `PhoneNumbers`
    Returns:
      Returns the AssociationList of `PhoneNumbers` which can be of type:
      Phone
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSubscriberIdentities

    AssociationList getSubscriberIdentities() throws RemoteException, MdException
    Gets the Association list of `SubscriberIdentities`
    Returns:
      The AssociationList of `SubscriberIdentities` which can be of type:
      ITSubscriber
      ITContentSubscriber
      ITEventSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEmailAddresses

    AssociationList getEmailAddresses(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `EmailAddresses`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `EmailAddresses` which can be of type:
      Email
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getLocations

    AssociationList getLocations(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Locations`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `Locations` which can be of type:
      Location
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPhoneNumbers

    AssociationList getPhoneNumbers(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `PhoneNumbers`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `PhoneNumbers` which can be of type:
      Phone
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSubscriberIdentities

    AssociationList getSubscriberIdentities(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SubscriberIdentities`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `SubscriberIdentities` which can be of type:
      ITSubscriber
      ITContentSubscriber
      ITEventSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setTitle

    void setTitle(String inTitle) throws RemoteException
    Sets the `Title` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inTitle` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTitle

    void setTitle(String inTitle, int state) throws RemoteException
    Sets the `Title` Metadata State.
    Parameters:
      `inTitle` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTitleState

    void setTitleState(int state) throws RemoteException
    Sets the Metadata State of `Title`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailAddresses

    void setEmailAddresses(AssociationList list) throws RemoteException
    Sets the `EmailAddresses` list to be `list`. Objects of which can be of type:
    Email
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailAddresses

    void setEmailAddresses(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLocations

    void setLocations(AssociationList list) throws RemoteException
    Sets the `Locations` list to be `list`. Objects of which can be of type:
    Location
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setLocations

    void setLocations(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPhoneNumbers

    void setPhoneNumbers(AssociationList list) throws RemoteException
    Sets the `PhoneNumbers` list to be `list`. Objects of which can be of type:
    Phone
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPhoneNumbers

    void setPhoneNumbers(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSubscriberIdentities

    void setSubscriberIdentities(AssociationList list) throws RemoteException
    Sets the `SubscriberIdentities` list to be `list`. Objects of which can be of type:
    ITSubscriber
    ITContentSubscriber
    ITEventSubscriber
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSubscriberIdentities

    void setSubscriberIdentities(AssociationList inObjects, int state) throws RemoteException
    Sets the entire SubscriberIdentities list to match the passed in AssociationList, sets the state of the SubscriberIdentities
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.